#include <stdio.h>
#include <windows.h>
#include <iostream>

using namespace std;
//
#define M 110
#define k 12


//#define M 2
//#define k 2

//#define M 240
//#define k 4

//# define RESTRICT restrict

void showMatrix(double *matrix, int matrixSize, int width);


int main()
{
	size_t matrixByteSize = M * M * k * k * sizeof(double);
	double*  matrix_A = (double*)_aligned_malloc(matrixByteSize, 16);
	double*  matrix_B = (double*)_aligned_malloc(matrixByteSize, 16);
	double*  matrix_C = (double*)_aligned_malloc(matrixByteSize, 16);

	if(matrix_A == NULL || matrix_B == NULL || matrix_C == NULL)
	{
		cout << "Allocate error!\n";
		system("pause");
		return 0;
	}

	int matrixSize = M * M * k * k;

	//  
	for(int i = 0; i < matrixSize; i++)
	{
		matrix_A[i] = i + 1;
		matrix_B[i] = i + 1;
		matrix_C[i] = 0;
	}

	DWORD startTime = timeGetTime();

	//   A  B,     C
	for(int i = 0; i < M; i++)
	{
		for(int j = 0; j < M; j++)
		{
			int index = i * M * k * k + j * k;
			for(int step = 0; step < M; step++)
			{
				int index1 = i * M * k * k + step * k;
				int index2 = step * M * k * k + j * k;


				// sse2 asm
				// sse2 intrinsic
				//  2.   ,  ,   ,   ,    
				for(int i_in = 0; i_in < k; i_in++)
				{			
					for(int step_in = 0; step_in < k; step_in++)
					{						
						//double tmp = matrix_A[index1 + i_in * (M + k)+ step_in];
						//#pragma vector always
						//#pragma simd vectorlengthfor(double)
						for(int j_in = 0; j_in < k; j_in++)
						{
							matrix_C[index + i_in * (M * k) + j_in] += 
								matrix_A[index1 + i_in * (M * k)+ step_in] * matrix_B[index2 + step_in * (M * k) + j_in];
						}
					}
				}
			}
		}
	}

	DWORD executionTime = timeGetTime() - startTime;
	cout << "Execution time is " << executionTime << " ms\n\n";

	/*
	showMatrix(matrix_A, matrixSize, M * k);
	showMatrix(matrix_B, matrixSize, M * k);
	showMatrix(matrix_C, matrixSize, M * k);
	*/

	system("pause");
	return 0;
}




void showMatrix(double *matrix, int matrixSize, int width)
{
	cout << "\n\n";
	for(int i = 0; i < matrixSize; i++)
	{
		cout << "\t" << matrix[i];

		if((i + 1) % width == 0)
			cout << endl;
	}
}