#include <windows.h>

#ifndef hr_timer
#include "hr_time.h"
#define hr_timer
#endif

double CStopWatch::LIToSeconds( LARGE_INTEGER & L) {
	return ((double)L.QuadPart /(double)frequency.QuadPart) ;
}

double CStopWatch::LIToMicroseconds( LARGE_INTEGER & L) {
	return ((double)L.QuadPart /(double)frequency.QuadPart * 1000000) ;
}

double CStopWatch::LIToMilliseconds( LARGE_INTEGER & L) {
	return ((double)L.QuadPart /(double)frequency.QuadPart * 1000) ;
}

CStopWatch::CStopWatch(){
	timer.start.QuadPart=0;
	timer.stop.QuadPart=0; 
	QueryPerformanceFrequency( &frequency ) ;
}

void CStopWatch::startTimer( ) {
	QueryPerformanceCounter(&timer.start) ;
}

void CStopWatch::stopTimer( ) {
	QueryPerformanceCounter(&timer.stop) ;
}

double CStopWatch::getElapsedTime_seconds() {
	LARGE_INTEGER time;
	time.QuadPart = timer.stop.QuadPart - timer.start.QuadPart;
	return LIToSeconds( time) ;
}

double CStopWatch::getElapsedTime_microseconds() {
	LARGE_INTEGER time;
	time.QuadPart = timer.stop.QuadPart - timer.start.QuadPart;
	return LIToMicroseconds( time) ;
}

double CStopWatch::getElapsedTime_milliseconds() {
	LARGE_INTEGER time;
	time.QuadPart = timer.stop.QuadPart - timer.start.QuadPart;
	return LIToMilliseconds( time) ;
}