
typedef unsigned int TColor;

// includes, project
#include <helper_functions.h> // includes for helper utility functions
#include <helper_cuda.h>      // includes for cuda error checking and initialization

#include "hr_time.h"


// functions to load images
extern "C" void LoadBMPFile(uchar4 **dst, int *width, int *height, const char *name);
extern "C" void SaveBMPFile(uchar4 *src, int width, int height, const char *name);

// CUDA kernel functions
extern "C" void cuda_Copy(TColor *d_dst, TColor *src, int imageW, int imageH);
extern "C" double cuda_Laplace(TColor *d_dst, TColor *src, int imageW, int imageH);
